Draft PolarArray: Difference between revisions

From FreeCAD Documentation
(Created page with "{{UnfinishedDocu}}")
 
No edit summary
(9 intermediate revisions by 4 users not shown)
Line 1: Line 1:
<languages/>
{{UnfinishedDocu}}
<translate>
<!--T:1-->
{{Docnav
|[[Draft_Draft2Sketch|Draft to Sketch]]
|[[Draft_LinkArray|Link Array]]
|[[Draft_Module|Draft]]
|IconL=Draft_Draft2Sketch.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_LinkArray.svg
}}

<!--T:2-->
{{GuiCommand
|Name=Draft PolarArray
|MenuLocation=Draft → Polar array
|Workbenches=[[Draft Module|Draft]]
|Version=0.19
|SeeAlso=[[Draft_Array|Array]], [[Draft_CircularArray|CircularArray]], [[Draft_PathArray|PathArray]], [[Draft_PointArray|PointArray]], [[Draft_Clone|Clone]]
}}

==Description== <!--T:3-->

<!--T:4-->
The {{Button|[[File:Draft_PolarArray.svg|16px]] [[Draft_PolarArray|Draft PolarArray]]}} tool creates an array from a selected object placing the copies along a circumference.

<!--T:5-->
This tool can be used on 2D shapes created with the [[Draft_Workbench|Draft Workbench]] but can also be used on many types of 3D objects such as those created with the [[Part_Workbench|Part Workbench]] or [[PartDesign_Workbench|PartDesign Workbench]].

<!--T:6-->
To position copies in a rectangular grid use [[Draft_Array|Array]]; to position in a circular pattern use [[Draft_CircularArray|CircularArray]]; to position copies along a path use [[Draft_PathArray|PathArray]]; to position copies at specified points use [[Draft_PointArray|PointArray]]; to create copies or clones, and manually place them use [[Draft_Move|Move]], [[Draft_Rotate|Rotate]], and [[Draft_Clone|Clone]].

</translate>
[[Image:Draft_PolarArray_example.png|400px]]
<translate>

<!--T:7-->
{{Caption|A polar array of an object.}}

== Usage == <!--T:8-->

<!--T:9-->
# Select an object from which you wish to make the polar array.
# Press the {{Button|[[File:Draft_PolarArray.svg|16px]] [[Draft_PolarArray|Polar array]]}} button. If no object is selected, the [[task_panel|task panel]] will open, but you still need to select an object to proceed.
# Choose the polar angle, which determines where the last element of the array will be.
# Choose the number of elements in the array. Minimum of 2, maximum of 99.
# Choose the center of the axis of rotation. You can click on the [[3D_view|3D view]], to simultaneously set the position of the center of rotation, and complete the command.
# Optionally, check the fuse or link options.
# Press {{Button|OK}} to complete the command.

<!--T:10-->
Notes:
* By default, the axis of rotation is the positive Z axis {{Value|(0, 0, 1)}}. This can be changed in the [[property_editor|property editor]] after the object is created.
* The polar angle is positive in the counter-clockwise direction, and negative in the clockwise direction.
* Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.
* This command creates the same object as the one created with the [[Draft_Array|Array]] and [[Draft_CircularArray|CircularArray]] tools. Therefore, the array can be converted to orthogonal, polar, or circular just by changing its properties.

== Options == <!--T:11-->

<!--T:12-->
* Press {{Button|Reset point}} to set the center of rotation to the origin {{Value|(0, 0, 0)}}.
* If the {{MenuCommand|Fuse}} checkbox is ticked, the resulting objects in the array will be fused into a single shape, if they touch or intersect each other.
* If the {{MenuCommand|Use Links}} checkbox is ticked, the resulting objects in the array will be [[App_Link|App Links]] instead of simple copies. This improves the memory usage of the array, as the App Link re-uses the [[Shape|shape]] of the original object, and does not create new shapes. If this option is used, the {{MenuCommand|Fuse}} checkbox has no effect.
* Press {{KEY|Esc}} or the {{Button|Cancel}} button to abort the current command.

== Properties == <!--T:13-->

<!--T:14-->
An [[Draft_PolarArray|Array]] object is based on [[Part_Feature|Part Feature]] ({{incode|Part::Feature}} class), and thus shares all properties of the latter. In addition to the properties listed in [[Part_Feature|Part Feature]], the Array object has additional properties.

<!--T:15-->
See the [[Draft_Array|Array]] tool for the complete information.

== Scripting == <!--T:16-->

<!--T:17-->
{{Emphasis|See also:}} [[Draft API|Draft API]] and [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]].

<!--T:18-->
The Array tool can be used in [[macros|macros]] and from the [[Python_console|Python console]] by using the following function.

</translate>
{{Code|code=
array_list = make_polar_array(obj, center, angle, number, use_link)
}}
<translate>

<!--T:19-->
* Creates an array from the objects contained in {{incode|obj}}, which can be a single object or a list of objects.
* The value of {{incode|center}} is a vector that defines the center of the array circle; {{incode|angle}} is the angle of the arc in degrees, and {{incode|number}} is the number of copies in the polar pattern, including the original object.
* If {{incode|use_link}} is {{TRUE}} the created copies will be [[App_Link|App Links]] and not regular copies.
* {{incode|array_list}} is returned with the new copies.
** {{incode|array_list}} is either a single object or a list of objects, depending on the input {{incode|obj}}.

<!--T:20-->
Example:
</translate>
{{Code|code=
import FreeCAD as App
import Draft
import draftobjects.polararray as pa

doc = App.newDocument()

tri = Draft.makePolygon(3, 600)
center = App.Vector(-1600, 0, 0)
arr = pa.make_polar_array(tri, center, 270, 8)
App.ActiveDocument.recompute()
}}
<translate>

<!--T:21-->
{{Docnav
|[[Draft_Draft2Sketch|Draft to Sketch]]
|[[Draft_LinkArray|Link Array]]
|[[Draft_Module|Draft]]
|IconL=Draft_Draft2Sketch.svg
|IconC=Workbench_Draft.svg
|IconR=Draft_LinkArray.svg
}}

</translate>
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}
{{clear}}

Revision as of 20:41, 21 February 2020

Draft PolarArray

Menu location
Draft → Polar array
Workbenches
Draft
Default shortcut
None
Introduced in version
0.19
See also
Array, CircularArray, PathArray, PointArray, Clone

Description

The Draft PolarArray tool creates an array from a selected object placing the copies along a circumference.

This tool can be used on 2D shapes created with the Draft Workbench but can also be used on many types of 3D objects such as those created with the Part Workbench or PartDesign Workbench.

To position copies in a rectangular grid use Array; to position in a circular pattern use CircularArray; to position copies along a path use PathArray; to position copies at specified points use PointArray; to create copies or clones, and manually place them use Move, Rotate, and Clone.

A polar array of an object.

Usage

  1. Select an object from which you wish to make the polar array.
  2. Press the Polar array button. If no object is selected, the task panel will open, but you still need to select an object to proceed.
  3. Choose the polar angle, which determines where the last element of the array will be.
  4. Choose the number of elements in the array. Minimum of 2, maximum of 99.
  5. Choose the center of the axis of rotation. You can click on the 3D view, to simultaneously set the position of the center of rotation, and complete the command.
  6. Optionally, check the fuse or link options.
  7. Press OK to complete the command.

Notes:

  • By default, the axis of rotation is the positive Z axis (0, 0, 1). This can be changed in the property editor after the object is created.
  • The polar angle is positive in the counter-clockwise direction, and negative in the clockwise direction.
  • Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.
  • This command creates the same object as the one created with the Array and CircularArray tools. Therefore, the array can be converted to orthogonal, polar, or circular just by changing its properties.

Options

  • Press Reset point to set the center of rotation to the origin (0, 0, 0).
  • If the Fuse checkbox is ticked, the resulting objects in the array will be fused into a single shape, if they touch or intersect each other.
  • If the Use Links checkbox is ticked, the resulting objects in the array will be App Links instead of simple copies. This improves the memory usage of the array, as the App Link re-uses the shape of the original object, and does not create new shapes. If this option is used, the Fuse checkbox has no effect.
  • Press Esc or the Cancel button to abort the current command.

Properties

An Array object is based on Part Feature (Part::Feature class), and thus shares all properties of the latter. In addition to the properties listed in Part Feature, the Array object has additional properties.

See the Array tool for the complete information.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The Array tool can be used in macros and from the Python console by using the following function.

array_list = make_polar_array(obj, center, angle, number, use_link)
  • Creates an array from the objects contained in obj, which can be a single object or a list of objects.
  • The value of center is a vector that defines the center of the array circle; angle is the angle of the arc in degrees, and number is the number of copies in the polar pattern, including the original object.
  • If use_link is true the created copies will be App Links and not regular copies.
  • array_list is returned with the new copies.
    • array_list is either a single object or a list of objects, depending on the input obj.

Example:

import FreeCAD as App
import Draft
import draftobjects.polararray as pa

doc = App.newDocument()

tri = Draft.makePolygon(3, 600)
center = App.Vector(-1600, 0, 0)
arr = pa.make_polar_array(tri, center, 270, 8)
App.ActiveDocument.recompute()